﻿info =
(
Pro/CQ码
CQ码，是指在酷Q Pro 的消息中，以“[CQ:”开头、“]”结尾的，可以实现特殊功能的代码。

结构
CQ码的结构为 [CQ:function,key=value,...]

其中function为功能名，key为参数名，value为参数值，key=value称为一组参数。

一个CQ码可以包含零组、一组或多组参数，功能名与每组参数之间用半角逗号“,”分割。

规范
CQ码是大小写敏感的，使用时请注意大小写。
对于不在CQ码内的消息（即文本消息），为了防止解析混淆，需要进行转义。
转义规则如下：
& -> &amp;
[ -> &#91;
] -> &#93;
CQ码中的function（功能名）与key（参数名），仅支持大小写字母、数字、短横线（-）、下划线（_）及点号（.）。
对于CQ码中的value（参数值），为了防止解析混淆，需要进行转义。
转义规则如下：
& -> &amp;
[ -> &#91;
] -> &#93;
, -> &#44;
目前支持的代码
[CQ:face,id={1}] - QQ表情
{1}为0-170的数字
举例：[CQ:face,id=14]（发送一个微笑的QQ表情）

[CQ:emoji,id={1}] - emoji表情
{1}为emoji字符的unicode编号
举例：[CQ:emoji,id=128513]（发送一个大笑的emoji表情）

[CQ:image,file={1}] - 发送自定义图片
{1}为图片文件名称，图片存放在酷Q目录的data\image\下
举例：[CQ:image,file=1.jpg]（发送data\image\1.jpg）

[CQ:at,qq={1}] - @某人（仅支持群消息使用）
{1}为被@的群成员QQ
举例：[CQ:at,qq=123456]

[CQ:shake] - 窗口抖动（仅支持好友消息使用）

[CQ:anonymous,ignore={1}] - 匿名发消息（仅支持群消息使用）
本CQ码需加在消息的开头。
当{1}为true时，代表不强制使用匿名，如果匿名失败将转为普通消息发送。
当{1}为false或ignore参数被忽略时，代表强制使用匿名，如果匿名失败将取消该消息的发送。
举例：
[CQ:anonymous,ignore=true]
[CQ:anonymous]

[CQ:music,id={1}] - 发送音乐（仅支持好友、群、讨论组消息使用）
{1}为QQ音乐的数字音乐id
注意：音乐只能作为单独的一条消息发送
举例：[CQ:music,id=422594]（发送一首“Time after time”歌曲到群内）
)
;隐藏窗口
Gui, Monitor:Add, Edit, x0 y0 w400 h100 vmsg
Gui, Monitor:Show, x-10 y-10 w0 h0, AHK_Monitor
Gui, Monitor:Show, , AHK_Monitor
Gui, Monitor:+hwndMonitorHwnd
Gui, Monitor:+LastFound
OnMessage(0x4A,"Receive_WM_COPYDATA")
Gui, Monitor:Hide
return

;调试发消息
#z::
SendMsg("好友","386283215",A_Now "[CQ:face,id=1]")
return

MonitorGuiClose:
return

;接收消息函数
Receive_WM_COPYDATA(wParam, lParam)
{
    StringAddress := NumGet(lParam + 2*A_PtrSize) ;获取文本指针
    length := NumGet(lParam + A_PtrSize)
    CopyOfData := StrGet(StringAddress,length) ;指针到文本
    return Deal(wParam,CopyOfData) ;消息号，信息
}

Deal(MsgCode,Msg){
    ToolTip, % Msg ;调试用
    if Msgcode=0
    {
        ;消息号[0]	好友┆QQ号┆昵称
        ;消息号[0]	群┆群号┆QQ号┆昵称
        return ;不需返回值
    }
    if Msgcode=1
    {
        ;消息号[1]	好友┆QQ号┆消息 	【返回0忽略消息 1拦截消息其他插件不再处理】
        ;Demo 回复同样消息 发过来的消息已经转义换行，不用再转义
        ;MsgEscape(消息)
        info := StrSplit(Msg,"┆") ;分割收到的消息
        SendMsg("好友",info[2],info[3]) ;按格式发送
        return 1
    }
    if Msgcode=
    {
        ;消息号[2]	群┆群号┆QQ号┆消息	【返回0忽略消息 1拦截消息其他插件不再处理】
        return 1
    }
    if Msgcode=
    {
        ;消息号[3]	讨论组┆讨论组号┆QQ号┆消息	【返回0忽略消息 1拦截消息其他插件不再处理】
        return 1
    }
    if Msgcode=
    {
        ;消息号[4]	陌生人┆类型【1/来自在线状态 2/来自群临时】┆群号┆QQ号┆消息	【返回0忽略消息 1拦截消息其他插件不再处理】
        return 1
    }
    if Msgcode=
    {
        ;消息号[5]	群上传┆群号┆QQ号┆消息	【返回0忽略消息 1拦截消息其他插件不再处理】
        return 1
    }
    if Msgcode=
    {
        ;消息号[6]	群管变动┆类型【1/被取消管理员 2/被设置管理员】┆群号┆被操作QQ号	【返回0忽略消息 1拦截消息其他插件不再处理】
        return 1
    }
    if Msgcode=
    {
        ;消息号[7]	群员减少┆类型【1/群员离开 2/群员被踢 3/自己(即登录号)被踢】┆群号┆QQ号┆被操作QQ号	【返回0忽略消息 1拦截消息其他插件不再处理】
        return 1
    }
    if Msgcode=
    {
        ;消息号[8]	群员增加┆类型【1/管理员已同意 2/管理员邀请】┆群号┆QQ号┆被操作QQ号	【返回0忽略消息 1拦截消息其他插件不再处理】
        return 1
    }
    if Msgcode=
    {
        ;消息号[9]	加好友┆QQ号┆消息 【返回0不处理 1同意 2拒绝】
        return 1
    }
    if Msgcode=
    {
        ;消息号[10]	加群┆群号┆QQ号┆消息 【返回1 同意 其他值不处理】
        return 1
    }
}


SendMsg(P*){
if (P[1] = "群" && P.maxindex()=3) ;群┆群号┆消息
    GuiControl, Monitor:, msg, % P[1] "┆" P[2] "┆" P[3]
else if (P[1] = "好友" && P.maxindex()=3) ;好友┆QQ号┆消息
    GuiControl, Monitor:, msg, % P[1] "┆" P[2] "┆" P[3]
else if (P[1] = "讨论组" && P.maxindex()=3) ;讨论组┆讨论组号┆消息
    GuiControl, Monitor:, msg, % P[1] "┆" P[2] "┆" P[3]
else if (P[1] = "群临时" && P.maxindex()=4) ;群临时┆群号┆QQ号┆消息
    GuiControl, Monitor:, msg, % P[1] "┆" P[2] "┆" P[3] "┆" P[4]
else if (P[1] = "在线临时" && P.maxindex()=2) 赞┆QQ号
    GuiControl, Monitor:, msg, % P[1] "┆" P[2]
else if (P[1] = "赞" && P.maxindex()=3) ;在线临时┆QQ号┆消息
    GuiControl, Monitor:, msg, % P[1] "┆" P[2] "┆" P[3]
else if (P[1] = "群员禁言" && P.maxindex()=4) ;群员禁言┆群号┆QQ号|禁言秒数（0取消）
    GuiControl, Monitor:, msg, % P[1] "┆" P[2] "┆" P[3] "┆" P[4]
else
    return -1
}

;消息转义函数 消息 是否转义CQ码 1转义
MsgEscape(Msg,EscapeCQPCode:=0){
if EscapeCQPCode=1
{
    StringReplace, Msg, Msg, &,  &amp;, All
    StringReplace, Msg, Msg, [,  &#91;, All
    StringReplace, Msg, Msg, ],  &#93;, All
    StringReplace, Msg, Msg, `,,  &#44;, All
}
StringReplace, Msg, Msg, `r,  , All
StringReplace, Msg, Msg, `n,  \n, All
return Msg
}

;文本到指针函数
StrPutVar(string, ByRef var, encoding:="")
{
    ; 确定容量.
    VarSetCapacity( var, StrPut(string, encoding) * ((encoding="utf-16"||encoding="cp1200") ? 2 : 1) )
    return StrPut(string, &var, encoding)
}